/// <reference types="react" />
import * as React from 'react';
export interface EmptyGitViewComponentGraphqlProps {
    cloneMutate: (args: any) => any;
    openMutate: (args: any) => any;
    closeMutate: () => any;
}
export interface IGitViewComponentDispatchProps {
    showInputModal: (description: string, dataType: string, placeholder?: string, inputType?: string) => void;
    setError: (error: string, type: string) => void;
    cleanCloneData: () => void;
    authCleanGit: () => void;
    confirmPath: (path: string) => void;
    showSelectModal: (data: [string], dataType: string, placeholder?: string) => void;
    gitAction: (command: string, args?: any) => void;
    checkAuth: () => void;
    setAuth: () => void;
    deletePath: () => void;
    setSelectedPath: (path: string) => void;
    openFile: (content: string, name: string, oldValue?: string, deleted?: boolean, addIgnore?: string) => void;
}
export interface IGitViewComponentStateProps {
    git: any;
    inputSelected: any;
    auth: any;
    rootpath: string;
    filesEdit: any;
    tree: any;
}
export declare type IGitViewProps = IGitViewComponentStateProps & IGitViewComponentDispatchProps & EmptyGitViewComponentGraphqlProps;
declare class GitViewContainer extends React.Component<IGitViewProps, {}> {
    componentWillReceiveProps(nextProps: IGitViewProps): void;
    private onGitAction;
    private actionMutate;
    private actionOpen;
    private actionClose;
    private actionShowStashList;
    private actionOpenChanges;
    private actionOpenGitIgnore;
    render(): JSX.Element;
}
export default GitViewContainer;
