module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 15);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = require("react");

/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = require("@git-stack/client-core");

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = require("react-fela");

/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = require("react-redux");

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = require("@git-stack/client-redux");

/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/client-modal-redux");

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const client_core_1 = __webpack_require__(1);
const lodash_1 = __webpack_require__(9);
exports.splitFilePath = (fullPath) => {
    return {
        folder: fullPath.replace(/\/[^\/]+$/, ''),
        file: fullPath.replace(/^.*[\\\/]/, ''),
    };
};
exports.getErrorText = errorObj => {
    if (errorObj.gitErrorDescription) {
        return errorObj.gitErrorDescription;
    }
    if (errorObj.stderr) {
        return errorObj.stderr;
    }
    return errorObj.stdout;
};
exports.getFolderName = (rootPath, repository) => {
    const folderNameArr = repository.split('/');
    const folderName = folderNameArr.pop().replace('.git', '');
    return `${rootPath}/${folderName}`;
};
exports.getPath = (item) => {
    return item.path ? `${item.path}/${item.name}` : item.name;
};
exports.getInputItem = (item) => {
    let path = exports.getPath(item);
    let originPath = (item.originPath && item.originPath !== '') ? item.originPath + '/' + item.originName : item.originName;
    return {
        status: item.status,
        path,
        originPath,
    };
};
exports.getChangesItemsPaths = (tree, stage) => {
    let groupData;
    let modifyItems;
    if (stage) {
        groupData = lodash_1.find(tree, item => item.group === client_core_1.GROUP.CHANGES);
        modifyItems = lodash_1.filter(groupData.items, item => item.status === 'modified');
    }
    else {
        groupData = lodash_1.find(tree, item => item.group === client_core_1.GROUP.STAGEDCHANGES);
        modifyItems = lodash_1.filter(groupData.items, item => item.status === 'index-modified');
    }
    return modifyItems.map(item => exports.getPath(item));
};
exports.readTextFile = (file, callback) => {
    const rawFile = new XMLHttpRequest();
    rawFile.open('GET', file, false);
    rawFile.onreadystatechange = () => {
        if (rawFile.readyState === 4) {
            if (rawFile.status === 200 || rawFile.status === 0) {
                const allText = rawFile.responseText;
                callback(allText);
            }
        }
    };
    rawFile.send(null);
};
exports.getGitObjByPath = (items, fullPath, selectedPath) => {
    let matchedItem;
    items.forEach(data => {
        data.items.forEach(item => {
            const itemPath = exports.getPath(item);
            if (`${fullPath}/${itemPath}` === selectedPath) {
                matchedItem = item;
            }
        });
    });
    return matchedItem;
};
exports.getNameByStatus = status => {
    let name = '(Working Tree)';
    if (status === 'index-modified') {
        name = '(Index)';
    }
    return name;
};


/***/ }),
/* 7 */
/***/ (function(module, exports) {

module.exports = require("react-apollo");

/***/ }),
/* 8 */
/***/ (function(module, exports) {

module.exports = require("@git-stack/graphql-gql");

/***/ }),
/* 9 */
/***/ (function(module, exports) {

module.exports = require("lodash");

/***/ }),
/* 10 */
/***/ (function(module, exports) {

module.exports = require("classnames");

/***/ }),
/* 11 */
/***/ (function(module, exports) {

module.exports = require("@files-stack/client-redux");

/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_fela_1 = __webpack_require__(2);
class ActionItemViewComponent extends React.Component {
    constructor() {
        super(...arguments);
        this.handlerClick = () => {
            if (this.props.onClick) {
                this.props.onClick('refetch');
            }
        };
    }
    render() {
        const { title, icon, styles } = this.props;
        return (React.createElement("a", { title: title },
            React.createElement("span", { className: styles[icon], onClick: this.handlerClick })));
    }
}
exports.ActionItemView = react_fela_1.connect({
    iconReload: ({ theme }) => ({
        background: `url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16'%3E%3Cpath d='M13.451 5.609l-.579-.939-1.068.812-.076.094c-.335.415-.927 1.341-1.124 2.876l-.021.165.033.163.071.345c0 1.654-1.346 3-3 3-.795 0-1.545-.311-2.107-.868-.563-.567-.873-1.317-.873-2.111 0-1.431 1.007-2.632 2.351-2.929v2.926s2.528-2.087 2.984-2.461h.012l3.061-2.582-4.919-4.1h-1.137v2.404c-3.429.318-6.121 3.211-6.121 6.721 0 1.809.707 3.508 1.986 4.782 1.277 1.282 2.976 1.988 4.784 1.988 3.722 0 6.75-3.028 6.75-6.75 0-1.245-.349-2.468-1.007-3.536z' fill='%232D2D30'/%3E%3Cpath d='M12.6 6.134l-.094.071c-.269.333-.746 1.096-.91 2.375.057.277.092.495.092.545 0 2.206-1.794 4-4 4-1.098 0-2.093-.445-2.817-1.164-.718-.724-1.163-1.718-1.163-2.815 0-2.206 1.794-4 4-4l.351.025v1.85s1.626-1.342 1.631-1.339l1.869-1.577-3.5-2.917v2.218l-.371-.03c-3.176 0-5.75 2.574-5.75 5.75 0 1.593.648 3.034 1.695 4.076 1.042 1.046 2.482 1.694 4.076 1.694 3.176 0 5.75-2.574 5.75-5.75-.001-1.106-.318-2.135-.859-3.012z' fill='%23C5C5C5'/%3E%3C/svg%3E") center center no-repeat`,
        height: '20px',
        width: '20px',
        display: 'block',
        margin: '0 3px',
    }),
    iconCommit: ({ theme }) => ({
        background: `url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16' viewBox='-2 -2 16 16' enable-background='new -2 -2 16 16'%3E%3Cpolygon fill='%23C5C5C5' points='9,0 4.5,9 3,6 0,6 3,12 6,12 12,0'/%3E%3C/svg%3E") center center no-repeat`,
        height: '20px',
        width: '20px',
        display: 'block',
        margin: '0 3px',
    }),
    iconGit: ({ theme }) => ({
        background: `url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' width='32' height='32'%3E%3Cdefs%3E%3CclipPath%3E%3Cpath d='M.06 91.886h91.828v-91.886h-91.828v91.886z'/%3E%3C/clipPath%3E%3CclipPath id='a'%3E%3Cpath d='M0 0h92v92h-92v-92z'/%3E%3C/clipPath%3E%3C/defs%3E%3Cpath d='M28.497 14.84l-11.354-11.353c-.653-.654-1.714-.654-2.368 0l-2.357 2.358 2.99 2.991c.695-.235 1.492-.077 2.046.477.557.558.713 1.361.473 2.059l2.882 2.882c.698-.241 1.502-.085 2.059.473.778.778.778 2.039 0 2.818-.779.779-2.04.779-2.819 0-.586-.586-.73-1.446-.434-2.167l-2.688-2.688v7.074c.19.094.369.219.527.377.778.778.778 2.039 0 2.819-.778.778-2.04.778-2.818 0-.778-.779-.778-2.04 0-2.819.192-.192.415-.338.653-.435v-7.14c-.237-.097-.46-.241-.653-.435-.589-.589-.731-1.455-.429-2.179l-2.948-2.949-7.785 7.785c-.654.655-.654 1.715 0 2.369l11.354 11.353c.654.654 1.714.654 2.369 0l11.3-11.301c.654-.654.654-1.715 0-2.369' fill='%23424242' clip-path='url%28%23a%29'/%3E%3C/svg%3E") center center no-repeat`,
        height: '20px',
        width: '20px',
        display: 'block',
        margin: '0 3px',
        'background-size': 'cover',
    }),
})(react_fela_1.withTheme(ActionItemViewComponent));


/***/ }),
/* 13 */
/***/ (function(module, exports) {

module.exports = require("reselect");

/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_redux_1 = __webpack_require__(3);
const client_redux_1 = __webpack_require__(4);
const TreeGroup_1 = __webpack_require__(32);
const mapDispatchToProps = (dispatch) => ({
    gitAction(command, item) {
        dispatch(client_redux_1.gitAction(command, item));
    },
});
exports.TreeGroup = react_redux_1.connect(null, mapDispatchToProps)(TreeGroup_1.default);


/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(16));
__export(__webpack_require__(6));


/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(17));
__export(__webpack_require__(44));


/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_redux_1 = __webpack_require__(3);
const react_apollo_1 = __webpack_require__(7);
const client_modal_redux_1 = __webpack_require__(5);
const client_redux_1 = __webpack_require__(11);
const client_redux_2 = __webpack_require__(4);
const graphql_gql_1 = __webpack_require__(8);
const GitView_1 = __webpack_require__(18);
const GitViewWithData = react_apollo_1.compose(react_apollo_1.graphql(graphql_gql_1.CLONE_MUTATE, { name: 'cloneMutate' }), react_apollo_1.graphql(graphql_gql_1.OPEN_MUTATE, { name: 'openMutate' }), react_apollo_1.graphql(graphql_gql_1.CLOSE_MUTATE, { name: 'closeMutate' }))(GitView_1.default);
const mapStateToProps = (state) => ({
    git: state.git_stack_commands,
    inputSelected: state.modalInput,
    auth: state.git_stack_auth,
    rootpath: state['@files/rootpath'],
    filesEdit: state['@files/edit'],
    tree: state.git_stack_tree,
});
const mapDispatchToProps = (dispatch) => ({
    showInputModal(description, dataType, placeholder, inputType) {
        dispatch(client_modal_redux_1.showInputModal(description, dataType, placeholder, inputType));
    },
    setError(error, type) {
        dispatch(client_modal_redux_1.setError(error, type));
    },
    cleanCloneData() {
        dispatch(client_redux_2.cleanCloneData());
    },
    confirmPath(path) {
        dispatch(client_redux_2.confirmPath(path));
    },
    showSelectModal(data, dataType, placeholder) {
        dispatch(client_modal_redux_1.showSelectModal(data, dataType, placeholder));
    },
    gitAction(command, args) {
        dispatch(client_redux_2.gitAction(command, args));
    },
    authCleanGit() {
        dispatch(client_redux_2.authCleanGit());
    },
    checkAuth() {
        dispatch(client_redux_2.checkAuth());
    },
    setAuth() {
        dispatch(client_redux_2.setAuth());
    },
    deletePath() {
        dispatch(client_redux_2.deletePath());
    },
    setSelectedPath(path) {
        dispatch(client_redux_2.setSelectedPath(path));
    },
    openFile(resource, name, oldValue, deleted, addIgnore) {
        dispatch(client_redux_1.openFileAction({ resource, name, oldValue, deleted, addIgnore }));
    },
});
exports.GitView = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(GitViewWithData);


/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const client_core_1 = __webpack_require__(1);
const utils_1 = __webpack_require__(6);
const ChangesView_1 = __webpack_require__(19);
const EmptyGitView_1 = __webpack_require__(42);
class GitViewContainer extends React.Component {
    constructor() {
        super(...arguments);
        this.onGitAction = (git, auth) => {
            switch (git.command) {
                case client_core_1.COMMAND.CLONE:
                    if (auth.loginStep === 2 && git.cloneStep === 2) {
                        return this.actionMutate(git.repository, git.rootPath, { login: auth.login, password: auth.password });
                    }
                    return;
                case client_core_1.COMMAND.SHOW_STASHES_LIST:
                    return this.actionShowStashList();
                case client_core_1.COMMAND.CLOSE_REPOSITORY:
                    return this.actionClose();
                case client_core_1.COMMAND.OPEN_CHANGES:
                    return this.actionOpenChanges(false);
                case client_core_1.COMMAND.OPEN_FILE_HEAD:
                    return this.actionOpenChanges(true);
                case client_core_1.COMMAND.ADD_TO_IGNOR:
                    return this.actionOpenGitIgnore();
                default:
                    return;
            }
        };
        this.actionMutate = (url, path, options) => {
            return this.props.cloneMutate({ variables: { url, path, options } })
                .then(({ data }) => {
                if (data.clone.exitCode) {
                    this.props.setError(utils_1.getErrorText(data.clone), 'error');
                }
                else {
                    const newPath = utils_1.getFolderName(this.props.git.rootPath, this.props.git.repository);
                    this.actionOpen(newPath);
                    this.props.setError('Repository was cloned', 'info');
                }
                this.props.cleanCloneData();
                this.props.authCleanGit();
            })
                .catch(err => {
                this.props.setError(err.toString(), 'error');
            });
        };
        this.actionOpen = (path) => {
            this.props.openMutate({ variables: { path } })
                .then(({ data }) => {
                if (!data.open.setPath.error) {
                    this.props.confirmPath(path);
                }
                else {
                    this.props.setError(data.open.setPath.error, 'error');
                }
            });
        };
        this.actionClose = () => {
            this.props.closeMutate()
                .then(() => {
                this.props.deletePath();
            });
        };
        this.actionShowStashList = () => {
            const { gitAction, showSelectModal, git: { stashList } } = this.props;
            if (!stashList.length) {
                return this.props.setError('There are no stashes to restore.', 'warn');
            }
            const picks = stashList.map(r => (`#${r.index}:  ${r.description}`));
            showSelectModal(picks, 'stashList', 'Pick a stash to pop');
            gitAction(client_core_1.COMMAND.POP_STASH);
        };
        this.actionOpenChanges = (head) => {
            const { tree, git, filesEdit: { selected }, setSelectedPath, gitAction } = this.props;
            const gitItem = utils_1.getGitObjByPath(tree.data, git.fullPath, selected);
            gitAction('');
            if (gitItem.status === 'modified' || gitItem.status === 'index-modified') {
                if (head) {
                    gitAction('openHead');
                }
                const path = utils_1.getPath(gitItem);
                setSelectedPath(path);
            }
        };
        this.actionOpenGitIgnore = () => {
            const { git: { fullPath }, gitAction, openFile, filesEdit } = this.props;
            gitAction('');
            const ignoreFile = filesEdit.selected.replace(`${fullPath}/`, '');
            openFile(`${fullPath}/.gitignore`, '.gitignore', null, false, ignoreFile);
        };
    }
    componentWillReceiveProps(nextProps) {
        const { git, auth, inputSelected: { selected, dataType }, showInputModal } = nextProps;
        if (git && git.calling) {
            this.onGitAction(git, auth);
        }
        if (auth.checkAuth) {
            if (!auth.userId) {
                this.props.showInputModal(client_core_1.DESCRIPTION.LOGIN, client_core_1.DATA_TYPE.LOGIN, client_core_1.PLACEHOLDER.LOGIN);
            }
            else {
                this.props.setAuth();
            }
            this.props.checkAuth();
        }
    }
    render() {
        const { isPathConfirm } = this.props.git;
        return (React.createElement("div", { className: "sidebar" },
            React.createElement("div", { className: "git-viewlet" }, isPathConfirm ? React.createElement(ChangesView_1.ChangesView, null) : React.createElement(EmptyGitView_1.EmptyGitView, null))));
    }
}
exports.default = GitViewContainer;


/***/ }),
/* 19 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_redux_1 = __webpack_require__(3);
const client_redux_1 = __webpack_require__(4);
const ChangesView_1 = __webpack_require__(20);
const mapStateToProps = (state) => ({
    git: state.git_stack_commands,
});
const mapDispatchToProps = (dispatch) => ({
    commitSetGit(commit) {
        dispatch(client_redux_1.commitSetGit(commit));
    },
    gitAction(command) {
        dispatch(client_redux_1.gitAction(command));
    },
});
exports.ChangesView = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(ChangesView_1.default);


/***/ }),
/* 20 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_fela_1 = __webpack_require__(2);
const ActionsView_1 = __webpack_require__(21);
const StatusView_1 = __webpack_require__(27);
const InputBox_1 = __webpack_require__(41);
class ChangesViewComponent extends React.Component {
    constructor(props) {
        super(props);
        this.handlerChange = (e) => this.setState({ message: e.target.value });
        this.handlerInputEnterKeyPress = (e) => {
            if (e.key === 'Enter') {
                this.handlerCommit();
            }
        };
        this.handlerCommit = () => {
            this.props.commitSetGit(this.state.message);
            this.props.gitAction('commit');
            this.setState({ message: '' });
        };
        this.state = {
            message: '',
        };
    }
    render() {
        const { message } = this.state;
        const { git: { onShowInputModal }, styles } = this.props;
        return (React.createElement("div", { className: styles.changesView },
            React.createElement(ActionsView_1.ActionsView, { handlerCommit: this.handlerCommit }),
            React.createElement(InputBox_1.InputBox, { options: { placeholder: 'message', value: message }, onChange: this.handlerChange, onKeyPress: this.handlerInputEnterKeyPress }),
            React.createElement(StatusView_1.StatusView, null)));
    }
}
exports.default = react_fela_1.connect({
    changesView: ({ theme }) => ({
        'margin-top': '20px',
        display: 'flex',
        'flex-direction': 'column',
        padding: '0 15px',
    }),
})(react_fela_1.withTheme(ChangesViewComponent));


/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_redux_1 = __webpack_require__(3);
const client_redux_1 = __webpack_require__(4);
const ActionsView_1 = __webpack_require__(22);
const mapDispatchToProps = (dispatch) => ({
    gitAction(command) {
        dispatch(client_redux_1.gitAction(command));
    },
});
exports.ActionsView = react_redux_1.connect(null, mapDispatchToProps)(ActionsView_1.default);


/***/ }),
/* 22 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_fela_1 = __webpack_require__(2);
const ActionItemView_1 = __webpack_require__(12);
const ActionMenuView_1 = __webpack_require__(23);
class ActionsViewComponent extends React.Component {
    constructor(props) {
        super(props);
        this.handlerMenuClick = () => { };
        this.handlerOpenMenu = () => this.setState({ openMenu: !this.state.openMenu });
        this.state = {
            openMenu: false,
        };
    }
    render() {
        const { openMenu } = this.state;
        const { styles } = this.props;
        return (React.createElement("div", { className: styles.actionsView },
            React.createElement("span", { className: "action-header" }, "Git"),
            React.createElement("div", { className: styles.actionsBar },
                React.createElement(ActionItemView_1.ActionItemView, { title: "Commit All", icon: "iconCommit", onClick: this.props.handlerCommit }),
                React.createElement(ActionItemView_1.ActionItemView, { title: "Refresh", icon: "iconReload", onClick: this.props.gitAction }),
                React.createElement(ActionMenuView_1.ActionMenuView, { openMenu: openMenu, onOpenMenu: this.handlerOpenMenu }))));
    }
}
exports.default = react_fela_1.connect({
    actionsView: ({ theme }) => ({
        display: 'flex',
        'justify-content': 'space-between',
    }),
    actionsBar: ({ theme }) => ({
        display: 'flex',
    }),
})(react_fela_1.withTheme(ActionsViewComponent));


/***/ }),
/* 23 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_redux_1 = __webpack_require__(3);
const client_redux_1 = __webpack_require__(4);
const client_modal_redux_1 = __webpack_require__(5);
const ActionMenuView_1 = __webpack_require__(24);
const mapStateToProps = (state) => ({
    auth: state.git_stack_auth,
});
const mapDispatchToProps = (dispatch) => ({
    gitAction(command) {
        dispatch(client_redux_1.gitAction(command));
    },
    authCleanGit() {
        dispatch(client_redux_1.authCleanGit());
    },
    setAuth() {
        dispatch(client_redux_1.setAuth());
    },
    showInputModal(description, dataType, placeholder, inputType) {
        dispatch(client_modal_redux_1.showInputModal(description, dataType, placeholder, inputType));
    },
});
exports.ActionMenuView = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(ActionMenuView_1.default);


/***/ }),
/* 24 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_fela_1 = __webpack_require__(2);
const client_core_1 = __webpack_require__(1);
const enhanceWithClickOutside = __webpack_require__(25);
const styles_1 = __webpack_require__(26);
class ActionMenuViewComponent extends React.Component {
    constructor() {
        super(...arguments);
        this.handlerMenuClick = (e) => {
            const data = e.target.attributes.getNamedItem('data-action').value;
            const { showInputModal } = this.props;
            if (data === client_core_1.COMMAND.COMMIT || data === client_core_1.COMMAND.COMMIT_ALL ||
                data === client_core_1.COMMAND.COMMIT_AMEND || data === client_core_1.COMMAND.COMMIT_SIGNED_OFF ||
                data === client_core_1.COMMAND.COMMIT_STAGED_AMEND || data === client_core_1.COMMAND.COMMIT_STAGED_SIGNED_OFF) {
                this.props.showInputModal(client_core_1.DESCRIPTION.LOGIN, client_core_1.DATA_TYPE.LOGIN, client_core_1.PLACEHOLDER.LOGIN);
            }
            if (data === client_core_1.COMMAND.STASH) {
                showInputModal(client_core_1.DESCRIPTION.STASH, client_core_1.DATA_TYPE.STASH, client_core_1.PLACEHOLDER.STASH);
            }
            if (data === client_core_1.COMMAND.PULL_FROM) {
                showInputModal(client_core_1.DESCRIPTION.BRANCH, client_core_1.DATA_TYPE.PULL_FROM, client_core_1.PLACEHOLDER.BRANCH);
            }
            if (data === client_core_1.COMMAND.PULL || data === client_core_1.COMMAND.PULL_REBASE ||
                data === client_core_1.COMMAND.PUSH || data === client_core_1.COMMAND.SYNC ||
                data === client_core_1.COMMAND.PUBLISH_BRANCH) {
                if (!this.props.auth.userId) {
                    this.props.showInputModal(client_core_1.DESCRIPTION.LOGIN, client_core_1.DATA_TYPE.LOGIN, client_core_1.PLACEHOLDER.LOGIN);
                }
                else {
                    this.props.setAuth();
                }
            }
            this.props.gitAction(data);
        };
    }
    handleClickOutside() {
        if (this.props.openMenu) {
            this.props.onOpenMenu();
        }
    }
    render() {
        const { openMenu, onOpenMenu, styles } = this.props;
        return (React.createElement(styles_1.MoreMenuContainer, { onClick: onOpenMenu },
            React.createElement("a", { title: "More" },
                React.createElement("span", { className: styles.iconMore })),
            openMenu &&
                React.createElement(styles_1.MoreGitMenu, null,
                    React.createElement(styles_1.BlockContainer, null,
                        React.createElement("div", { "data-action": client_core_1.COMMAND.PULL, onClick: this.handlerMenuClick }, "Pull"),
                        React.createElement("div", { "data-action": client_core_1.COMMAND.PULL_REBASE, onClick: this.handlerMenuClick }, "Pull (Rebase)"),
                        React.createElement("div", { "data-action": client_core_1.COMMAND.PULL_FROM, onClick: this.handlerMenuClick }, "Pull from ..."),
                        React.createElement("div", { "data-action": client_core_1.COMMAND.PUSH, onClick: this.handlerMenuClick }, "Push"),
                        React.createElement("div", { "data-action": client_core_1.COMMAND.SYNC, onClick: this.handlerMenuClick }, "Sync")),
                    React.createElement(styles_1.Line, null),
                    React.createElement(styles_1.BlockContainer, null,
                        React.createElement("div", { "data-action": client_core_1.COMMAND.PUBLISH_BRANCH, onClick: this.handlerMenuClick }, "Publish Branch")),
                    React.createElement(styles_1.Line, null),
                    React.createElement(styles_1.BlockContainer, null,
                        React.createElement("div", { "data-action": client_core_1.COMMAND.COMMIT_ALL, onClick: this.handlerMenuClick }, "Commit All"),
                        React.createElement("div", { "data-action": client_core_1.COMMAND.COMMIT_AMEND, onClick: this.handlerMenuClick }, "Commit All (Amend)"),
                        React.createElement("div", { "data-action": client_core_1.COMMAND.COMMIT_SIGNED_OFF, onClick: this.handlerMenuClick }, "Commit All (Signed Off)"),
                        React.createElement("div", { "data-action": client_core_1.COMMAND.COMMIT, onClick: this.handlerMenuClick }, "Commit Staged"),
                        React.createElement("div", { "data-action": client_core_1.COMMAND.COMMIT_STAGED_AMEND, onClick: this.handlerMenuClick }, "Commit Staged (Amend)"),
                        React.createElement("div", { "data-action": client_core_1.COMMAND.COMMIT_STAGED_SIGNED_OFF, onClick: this.handlerMenuClick }, "Commit Staged (Signed Off)")),
                    React.createElement(styles_1.Line, null),
                    React.createElement(styles_1.BlockContainer, null,
                        React.createElement("div", { "data-action": client_core_1.COMMAND.DISCARD_ALL_CHANGES, onClick: this.handlerMenuClick }, "Discard all changes"),
                        React.createElement("div", { "data-action": "add", onClick: this.handlerMenuClick }, "Stage all changes"),
                        React.createElement("div", { "data-action": "delete", onClick: this.handlerMenuClick }, "Unstage All Changes")),
                    React.createElement(styles_1.Line, null),
                    React.createElement(styles_1.BlockContainer, null,
                        React.createElement("div", { "data-action": client_core_1.COMMAND.STASH, onClick: this.handlerMenuClick }, "Stash"),
                        React.createElement("div", { "data-action": client_core_1.COMMAND.POP_LATEST_STASH, onClick: this.handlerMenuClick }, "Pop Latest Stash"),
                        React.createElement("div", { "data-action": "showStashesList", onClick: this.handlerMenuClick }, "Pop Stash...")))));
    }
}
exports.default = react_fela_1.connect({
    iconMore: ({ theme }) => ({
        background: `url("data:image/svg+xml,%3C%3Fxml version='1.0' encoding='iso-8859-1'%3F%3E%3C!DOCTYPE svg PUBLIC '-//W3C//DTD SVG 1.1//EN' 'http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd'%3E%3Csvg xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' version='1.1' id='Capa_1' x='0px' y='0px' width='512px' height='512px' viewBox='0 0 612 612' style='enable-background:new 0 0 612 612;' xml:space='preserve'%3E%3Cg%3E%3Cg%3E%3Ccircle cx='69.545' cy='306' r='69.545' fill='%23FFFFFF'/%3E%3Ccircle cx='306' cy='306' r='69.545' fill='%23FFFFFF'/%3E%3Ccircle cx='542.455' cy='306' r='69.545' fill='%23FFFFFF'/%3E%3C/g%3E%3C/g%3E%3C/svg%3E%0A") center center no-repeat`,
        'background-size': 'cover',
        margin: '0 3px',
        height: '20px',
        width: '20px',
        display: 'block',
    }),
})(react_fela_1.withTheme(enhanceWithClickOutside(ActionMenuViewComponent)));


/***/ }),
/* 25 */
/***/ (function(module, exports) {

module.exports = require("react-click-outside");

/***/ }),
/* 26 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_fela_1 = __webpack_require__(2);
const IconMoreRule = (props) => ({
    backgroundImage: `url(../../media/more-button.svg) center center no-repeat`,
    backgroundSize: 'cover',
    margin: '0 3px',
    height: 20,
    width: 20,
    display: 'block',
});
exports.IconMore = react_fela_1.createComponent(IconMoreRule, 'span');
const MoreMenuContainerRule = () => ({
    position: 'relative',
    cursor: 'pointer',
});
exports.MoreMenuContainer = react_fela_1.createComponent(MoreMenuContainerRule, 'div', ['onClick']);
const MoreGitMenuRule = () => ({
    position: 'absolute',
    background: '#ffffff',
    borderRadius: 5,
    color: '#373a3c',
    minWidth: '200px',
    padding: '10px 0',
    zIndex: '1',
    border: '1px solid #eee',
});
exports.MoreGitMenu = react_fela_1.createComponent(MoreGitMenuRule, 'div', ['onClick']);
const BlockContainerRule = () => ({
    padding: '0px 10px',
});
exports.BlockContainer = react_fela_1.createComponent(BlockContainerRule, 'div');
const LineRule = () => ({
    border: 'none',
    color: '#eee',
    backgroundColor: '#eee',
    height: '1px',
    marginTop: '10px',
    marginBottom: '10px',
});
exports.Line = react_fela_1.createComponent(LineRule, 'hr');


/***/ }),
/* 27 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_redux_1 = __webpack_require__(3);
const reselect_1 = __webpack_require__(13);
const react_apollo_1 = __webpack_require__(7);
const client_core_1 = __webpack_require__(1);
const client_redux_1 = __webpack_require__(4);
const client_modal_redux_1 = __webpack_require__(5);
const client_modal_redux_2 = __webpack_require__(5);
const graphql_gql_1 = __webpack_require__(8);
const StatusView_1 = __webpack_require__(28);
const StatusViewWithData = react_apollo_1.compose(react_apollo_1.graphql(graphql_gql_1.UNSTAGE_MUTATE, { name: 'unstageMutate' }), react_apollo_1.graphql(graphql_gql_1.CLEAN_MUTATE, { name: 'cleanMutate' }), react_apollo_1.graphql(graphql_gql_1.ADD_MUTATE, { name: 'addMutate' }), react_apollo_1.graphql(graphql_gql_1.COMMIT_ALL_MUTATE, { name: 'commitAllMutate' }), react_apollo_1.graphql(graphql_gql_1.COMMIT_MUTATE, { name: 'commitMutate' }), react_apollo_1.graphql(graphql_gql_1.STASH_MUTATE, { name: 'stashMutate' }), react_apollo_1.graphql(graphql_gql_1.UNSTASH_MUTATE, { name: 'unstashMutate' }), react_apollo_1.graphql(graphql_gql_1.BRANCH_MUTATE, { name: 'branchMutate' }), react_apollo_1.graphql(graphql_gql_1.TAG_MUTATE, { name: 'tagMutate' }), react_apollo_1.graphql(graphql_gql_1.DELETE_BRANCH_MUTATE, { name: 'deleteBranchMutate' }), react_apollo_1.graphql(graphql_gql_1.MERGE_MUTATE, { name: 'mergeMutate' }), react_apollo_1.graphql(graphql_gql_1.UNDO_LAST_COMMIT_MUTATE, { name: 'undoLastCommitMutate' }), react_apollo_1.graphql(graphql_gql_1.STASHES_QUERY, { props: reselect_1.createSelector(({ ownProps, data }) => data, (data) => { return { stashes: data.stashes, stashesRefetch: data.refetch }; }) }), react_apollo_1.graphql(graphql_gql_1.STATUS_QUERY, {
    props: reselect_1.createSelector(({ ownProps, data }) => data, (data) => {
        const status = data.status ? data.status.status : [];
        return {
            gitStatus: client_core_1.convertGitStatusToChanges(status),
            refetch: data.refetch,
        };
    }),
}))(StatusView_1.default);
const mapStateToProps = (state) => ({
    git: state.git_stack_commands,
    tree: state.git_stack_tree.data,
    selectedModal: state.selectModal.selected,
    gitAuth: state.git_stack_auth,
});
const mapDispatchToProps = (dispatch) => ({
    setTreeData(data) {
        dispatch(client_redux_1.setTreeData(data));
    },
    resetGit() {
        dispatch(client_redux_1.resetGit());
    },
    authCleanGit() {
        dispatch(client_redux_1.authCleanGit());
    },
    setError(error, type) {
        dispatch(client_modal_redux_2.setError(error, type));
    },
    commitCleanGit() {
        dispatch(client_redux_1.commitCleanGit());
    },
    cleanBranch() {
        dispatch(client_redux_1.cleanBranch());
    },
    cleanTag() {
        dispatch(client_redux_1.cleanTag());
    },
    setCurrentBranch(name) {
        dispatch(client_redux_1.setCurrentBranch(name));
    },
    setStashes(stashes) {
        dispatch(client_redux_1.setStashes(stashes));
    },
    saveUser(id) {
        dispatch(client_redux_1.saveUser(id));
    },
    gitAction(command, item) {
        dispatch(client_redux_1.gitAction(command, item));
    },
    setAuth() {
        dispatch(client_redux_1.setAuth());
    },
    deleteRef(name) {
        dispatch(client_redux_1.deleteRef(name));
    },
    deleteStashMessage() {
        dispatch(client_redux_1.deleteStashMessage());
    },
    showInputModal(description, dataType, placeholder, inputType) {
        dispatch(client_modal_redux_1.showInputModal(description, dataType, placeholder, inputType));
    },
    refresh(refresh) {
        dispatch(client_redux_1.refreshAction(refresh));
    },
});
exports.StatusView = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(StatusViewWithData);


/***/ }),
/* 28 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const lodash_1 = __webpack_require__(9);
const client_core_1 = __webpack_require__(1);
const utils_1 = __webpack_require__(6);
const tree_1 = __webpack_require__(29);
const styles_1 = __webpack_require__(40);
class StatusViewComponent extends React.Component {
    constructor(props) {
        super(props);
        this.onGitAction = (git, selectedModal) => {
            switch (git.command) {
                case client_core_1.COMMAND.STAGE:
                    return this.doAction(this.actionStage([utils_1.getInputItem(git.args).path]));
                case client_core_1.COMMAND.UNSTAGE:
                    return this.doAction(this.actionUnstage([utils_1.getInputItem(git.args).path]));
                case client_core_1.COMMAND.CLEAN:
                    return this.doAction(this.actionClean([utils_1.getInputItem(git.args).path]));
                case client_core_1.COMMAND.STAGE_ALL:
                    return this.doAction(this.actionStage());
                case client_core_1.COMMAND.STAGE_CHANGES:
                    return this.doAction(this.actionStage(utils_1.getChangesItemsPaths(this.props.tree, true)));
                case client_core_1.COMMAND.DISCARD_ALL_CHANGES:
                    return this.doAction(this.actionClean());
                case client_core_1.COMMAND.DISCARD_CHANGES:
                    return this.doAction(this.actionClean(utils_1.getChangesItemsPaths(this.props.tree, true)));
                case client_core_1.COMMAND.UNSTAGE_ALL_CHANGES:
                    return this.doAction(this.actionUnstage());
                case client_core_1.COMMAND.UNSTAGE_CHANGES:
                    return this.doAction(this.actionUnstage(utils_1.getChangesItemsPaths(this.props.tree)));
                case client_core_1.COMMAND.COMMIT_ALL:
                    if (!git.commit) {
                        return;
                    }
                    return this.doAction(this.actionCommitAll(git.commit));
                case client_core_1.COMMAND.COMMIT_AMEND:
                    if (!git.commit) {
                        return;
                    }
                    return this.doAction(this.actionCommitAll(git.commit, { amend: true }));
                case client_core_1.COMMAND.COMMIT_SIGNED_OFF:
                    if (!git.commit) {
                        return;
                    }
                    return this.doAction(this.actionCommitAll(git.commit, { signoff: true }));
                case client_core_1.COMMAND.COMMIT:
                    if (!git.commit) {
                        return;
                    }
                    return this.doAction(this.actionCommit(git.commit));
                case client_core_1.COMMAND.COMMIT_STAGED_AMEND:
                    if (!git.commit) {
                        return;
                    }
                    return this.doAction(this.actionCommit(git.commit, { amend: true }));
                case client_core_1.COMMAND.COMMIT_STAGED_SIGNED_OFF:
                    if (!git.commit) {
                        return;
                    }
                    return this.doAction(this.actionCommit(git.commit, { signoff: true }));
                case client_core_1.COMMAND.CREATE_BRANCH:
                    if (!git.branch) {
                        return;
                    }
                    return this.actionCreateBranch(git.branch, true);
                case client_core_1.COMMAND.STASH:
                    if (!git.isStashMessage) {
                        return;
                    }
                    return this.doAction(this.actionStash(git.stashMessage));
                case client_core_1.COMMAND.POP_LATEST_STASH:
                    return this.doAction(this.actionUnStash());
                case client_core_1.COMMAND.POP_STASH:
                    if (!selectedModal) {
                        return;
                    }
                    const index = Number(selectedModal[1]);
                    return this.doAction(this.actionUnStash(index));
                case client_core_1.COMMAND.CREATE_TAG:
                    if (git.tagStep !== 2) {
                        return;
                    }
                    return this.actionTag(git.tag, git.tagMessage);
                case client_core_1.COMMAND.DELETE_BRANCH:
                    if (!selectedModal) {
                        return;
                    }
                    return this.actionDeleteBranch(selectedModal);
                case client_core_1.COMMAND.MERGE_BRANCH:
                    if (!selectedModal) {
                        return;
                    }
                    return this.doAction(this.actionMerge(selectedModal));
                case client_core_1.COMMAND.UNDO_LAST_COMMIT:
                    return this.doAction(this.actionUndoLastCommit());
                default:
                    return;
            }
        };
        this.actionRefetch = () => {
            this.props.refresh(false);
            this.props.refetch();
        };
        this.actionStage = (paths) => {
            return this.props.addMutate({
                variables: { paths },
            }).then(({ data }) => {
                return data.add;
            });
        };
        this.actionUnstage = (paths) => {
            return this.props.unstageMutate({
                variables: { paths },
            }).then(({ data }) => {
                return data.unstage;
            });
        };
        this.actionClean = (paths) => {
            return this.props.cleanMutate({
                variables: { paths },
            }).then(({ data }) => {
                return data.clean;
            });
        };
        this.actionCommitAll = (message, opts) => {
            return this.props.commitAllMutate({
                variables: { message, opts },
            })
                .then(({ data }) => {
                this.props.commitCleanGit();
                return data.commitAll;
            });
        };
        this.actionCommit = (message, opts) => {
            return this.props.commitMutate({
                variables: { message, opts },
            }).then(({ data }) => {
                this.props.commitCleanGit();
                return data.commit;
            });
        };
        this.actionStash = (message) => {
            this.props.deleteStashMessage();
            return this.props.stashMutate({
                variables: { message },
            })
                .then(({ data }) => {
                this.props.stashesRefetch();
                return data.stash;
            });
        };
        this.actionUnStash = (index) => {
            this.props.gitAction('');
            return this.props.unstashMutate({
                variables: { index },
            })
                .then(({ data }) => {
                this.props.stashesRefetch();
                return data.unstash;
            });
        };
        this.actionCreateBranch = (name, checkout) => {
            this.props.cleanBranch();
            return this.props.branchMutate({
                variables: { name, checkout },
            }).then(({ data }) => {
                if (data.createBranch.exitCode) {
                    this.props.setError(utils_1.getErrorText(data.createBranch), 'error');
                }
                else {
                    this.props.setCurrentBranch(name);
                    this.props.setError(`Checkout to branch '${name}'`, 'info');
                }
            });
        };
        this.actionDeleteBranch = (name) => {
            return this.props.deleteBranchMutate({
                variables: { name },
            }).then(({ data }) => {
                if (data.deleteBranch.exitCode) {
                    this.props.setError(utils_1.getErrorText(data.deleteBranch), 'error');
                }
                else {
                    this.props.deleteRef(name);
                    this.props.setError(`Branch '${name}' was deleted`, 'info');
                }
            });
        };
        this.actionMerge = (branch) => {
            this.props.gitAction('');
            return this.props.mergeMutate({
                variables: { branch },
            }).then(({ data }) => {
                console.log('data', data);
                if (!data.merge.exitCode) {
                    this.props.setError(`Merge branch '${branch}'`, 'info');
                }
                return data.merge;
            });
        };
        this.actionTag = (name, message) => {
            this.props.cleanTag();
            return this.props.tagMutate({
                variables: { name, message },
            }).then(({ data }) => {
                if (data.tag.exitCode) {
                    this.props.setError(utils_1.getErrorText(data.tag), 'error');
                }
                else {
                    this.props.setError(`Tag '${name}' was created`, 'info');
                }
            });
        };
        this.actionUndoLastCommit = () => {
            return this.props.undoLastCommitMutate()
                .then(({ data }) => {
                return data.undoLastCommit;
            });
        };
        this.state = {
            gitLoad: false,
            timer: null,
        };
    }
    componentDidMount() {
        let timer = setInterval(this.actionRefetch, 5000);
        this.setState({ timer });
    }
    componentWillReceiveProps(nextProps) {
        const { gitStatus, git, gitAuth, refs, stashes, authData, selectedModal } = nextProps;
        if (this.props.stashes !== stashes) {
            this.props.setStashes(stashes);
        }
        if (!this.state.gitLoad || !lodash_1.isEqual(gitStatus, this.props.gitStatus)) {
            this.props.setTreeData(gitStatus);
            this.setState({ gitLoad: true });
        }
        if (git && git.calling) {
            this.onGitAction(git, selectedModal);
        }
        if (git.refresh) {
            this.actionRefetch();
        }
    }
    componentWillUnmount() {
        this.setState({ timer: null });
        this.props.refetch();
        this.props.stashesRefetch();
    }
    doAction(promise) {
        promise.then((data) => {
            this.props.setTreeData(client_core_1.convertGitStatusToChanges(data.status));
            this.props.resetGit();
            if (data.exitCode) {
                this.props.setError(utils_1.getErrorText(data), 'error');
            }
        }).catch((error) => {
            console.log('There was an error sending the stage query', error);
        });
    }
    render() {
        return (React.createElement(styles_1.StatusView, { className: "status-view" },
            React.createElement(tree_1.Tree, null)));
    }
}
exports.default = StatusViewComponent;


/***/ }),
/* 29 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var Tree_1 = __webpack_require__(30);
exports.Tree = Tree_1.Tree;
var TreeGroup_1 = __webpack_require__(14);
exports.TreeGroup = TreeGroup_1.TreeGroup;


/***/ }),
/* 30 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_redux_1 = __webpack_require__(3);
const Tree_1 = __webpack_require__(31);
const mapStateToProps = (state) => ({
    data: state.git_stack_tree.data,
});
exports.Tree = react_redux_1.connect(mapStateToProps)(Tree_1.default);


/***/ }),
/* 31 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_fela_1 = __webpack_require__(2);
const TreeGroup_1 = __webpack_require__(14);
class TreeComponent extends React.Component {
    constructor() {
        super(...arguments);
        this.moveItems = (args) => { };
    }
    render() {
        const { styles } = this.props;
        return (React.createElement("div", { className: styles.monacoTree },
            React.createElement("div", { className: styles.monacoScrollableElement },
                React.createElement("div", { className: styles.monacoTreeWrapper }, this.props.data && this.props.data.map((groupData, i) => (React.createElement(TreeGroup_1.TreeGroup, { key: i, group: groupData.group, data: groupData.items, onMoveItem: this.moveItems })))))));
    }
}
exports.default = react_fela_1.connect({
    monacoScrollableElement: ({ theme }) => ({
        height: '100%',
    }),
    monacoTreeWrapper: ({ theme }) => ({
        height: '100%',
        width: '100%',
        position: 'relative',
    }),
    monacoTree: ({ theme }) => ({
        height: '100%',
        width: '100%',
        'white-space': 'nowrap',
        '-webkit-user-select': 'none',
        '-khtml-user-select': 'none',
        '-moz-user-select': '-moz-none',
        '-ms-user-select': 'none',
        '-o-user-select': 'none',
        'user-select': 'none',
        position: 'relative',
    }),
})(react_fela_1.withTheme(TreeComponent));


/***/ }),
/* 32 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_fela_1 = __webpack_require__(2);
const react_contextmenu_1 = __webpack_require__(33);
const client_core_1 = __webpack_require__(1);
const TreeItem_1 = __webpack_require__(34);
const TreeGroupHeader_1 = __webpack_require__(37);
class TreeGroupComponent extends React.Component {
    constructor(props) {
        super(props);
        this.handleMenuClick = (e, attrs, el) => {
            this.props.gitAction(attrs.action, attrs.item);
        };
    }
    render() {
        const { group, data, isDropping, gitAction, styles, } = this.props;
        const menuType = group;
        if (!data.length) {
            return null;
        }
        return (React.createElement("div", { className: styles.monacoTreeRows },
            isDropping ? React.createElement("div", { className: styles.dropOverlay }) : null,
            React.createElement(TreeGroupHeader_1.TreeGroupHeader, { group: group, count: data.length, onAction: gitAction }),
            React.createElement("div", { className: styles.row }, data.map((item, i) => (React.createElement("div", { key: i },
                React.createElement(react_contextmenu_1.ContextMenuTrigger, { id: menuType, holdToDisplay: -1 },
                    React.createElement(TreeItem_1.TreeItem, { item: item, group: group, itemIndex: i })),
                React.createElement(react_contextmenu_1.ContextMenu, { id: menuType, className: styles.contextMenu },
                    React.createElement(react_contextmenu_1.MenuItem, { data: { action: 'open-change', item }, onClick: this.handleMenuClick }, "Open Change"),
                    React.createElement(react_contextmenu_1.MenuItem, { data: { action: 'open-file', item }, onClick: this.handleMenuClick }, "Open File"),
                    React.createElement(react_contextmenu_1.MenuItem, { divider: true }),
                    group === client_core_1.GROUP.CHANGES &&
                        React.createElement("div", null,
                            React.createElement(react_contextmenu_1.MenuItem, { data: { action: client_core_1.COMMAND.STAGE, item }, onClick: this.handleMenuClick }, "Stage"),
                            React.createElement(react_contextmenu_1.MenuItem, { data: { action: client_core_1.COMMAND.CLEAN, item }, onClick: this.handleMenuClick }, "Clean")),
                    group === client_core_1.GROUP.STAGEDCHANGES &&
                        React.createElement(react_contextmenu_1.MenuItem, { data: { action: client_core_1.COMMAND.UNSTAGE, item }, onClick: this.handleMenuClick }, "Unstage"),
                    group === client_core_1.GROUP.MERGECHANGES &&
                        React.createElement(react_contextmenu_1.MenuItem, { data: { action: client_core_1.COMMAND.STAGE, item }, onClick: this.handleMenuClick }, "Stage"))))))));
    }
}
exports.default = react_fela_1.connect({
    monacoTreeRows: ({ theme }) => ({
        position: 'relative',
        'margin-bottom': '12px',
        overflow: 'auto',
    }),
    dropOverlay: ({ theme }) => ({
        position: 'absolute',
        left: 0,
        top: 0,
        width: '100%',
        height: '100%',
        background: 'white',
        opacity: .1,
    }),
    row: ({ theme }) => ({
        margin: '20px 0 50px 0',
    }),
    contextMenu: ({ theme }) => ({
        background: 'white',
        padding: '10px',
    }),
})(react_fela_1.withTheme(TreeGroupComponent));


/***/ }),
/* 33 */
/***/ (function(module, exports) {

module.exports = require("react-contextmenu");

/***/ }),
/* 34 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_redux_1 = __webpack_require__(3);
const react_apollo_1 = __webpack_require__(7);
const client_redux_1 = __webpack_require__(4);
const client_redux_2 = __webpack_require__(11);
const graphql_gql_1 = __webpack_require__(8);
const TreeItem_1 = __webpack_require__(35);
const TreeItemWithData = react_apollo_1.compose(react_apollo_1.graphql(graphql_gql_1.HEAD_CONTENT_QUERY, {
    skip: ({ selectedPath }) => !selectedPath,
    options: ({ selectedPath }) => ({ variables: { resource: selectedPath } }),
    props: ({ data: { headContent, refetch } }) => ({ headContent: headContent, refetch }),
}))(TreeItem_1.default);
const mapStateToProps = (state) => ({
    fullPath: state.git_stack_commands.fullPath,
    selectedPath: state.git_stack_commands.selectedPath,
    git: state.git_stack_commands,
});
const mapDispatchToProps = (dispatch) => ({
    gitAction(command, item) {
        dispatch(client_redux_1.gitAction(command, item));
    },
    openFile(resource, name, oldValue, deleted, addIgnore) {
        dispatch(client_redux_2.openFileAction({ resource, name, oldValue, deleted, addIgnore }));
    },
    setSelectedPath(path) {
        dispatch(client_redux_1.setSelectedPath(path));
    },
});
exports.TreeItem = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(TreeItemWithData);


/***/ }),
/* 35 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const cx = __webpack_require__(10);
const felaStyles = __webpack_require__(36);
const react_fela_1 = __webpack_require__(2);
const client_core_1 = __webpack_require__(1);
const utils_1 = __webpack_require__(6);
class TreeItemComponent extends React.Component {
    constructor() {
        super(...arguments);
        this.handlerStage = () => {
            const { item } = this.props;
            this.props.gitAction(client_core_1.COMMAND.STAGE, item);
        };
        this.handlerClean = () => {
            const { item } = this.props;
            this.props.gitAction(client_core_1.COMMAND.CLEAN, item);
        };
        this.handlerUnstage = () => {
            const { item } = this.props;
            this.props.gitAction(client_core_1.COMMAND.UNSTAGE, item);
        };
        this.handlerOpen = () => {
            const { item, fullPath, setSelectedPath, openFile } = this.props;
            const path = utils_1.getPath(item);
            if (item.status === 'modified' || item.status === 'index-modified' ||
                item.status === 'deleted' || item.status === 'index-deleted') {
                setSelectedPath(path);
            }
            else if (item.status === 'untracked' || item.status === 'index-added' || item.status === 'both-modified') {
                openFile(`${fullPath}/${path}`, item.name);
            }
        };
    }
    componentWillMount() {
        this.setItemState(this.props.item);
    }
    componentWillReceiveProps(nextProps, nextState) {
        this.setItemState(nextProps.item);
        if (nextProps.headContent && this.props.headContent !== nextProps.headContent && nextProps.headContent.path === this.props.selectedPath) {
            const { item, fullPath, selectedPath, setSelectedPath, openFile, git } = nextProps;
            const path = utils_1.getPath(item);
            if (path === selectedPath) {
                if (git.command === client_core_1.COMMAND.OPEN_HEAD) {
                    openFile(`${fullPath}/${path}`, `${item.name} (HEAD)`, nextProps.headContent.stdout, true);
                }
                else if (item.status === 'deleted' || item.status === 'index-deleted') {
                    openFile(`${fullPath}/${path}`, item.name, nextProps.headContent.stdout, true);
                }
                else {
                    let name = utils_1.getNameByStatus(item.status);
                    openFile(`${fullPath}/${path}`, `${item.name} ${name}`, nextProps.headContent.stdout);
                }
                setSelectedPath('');
                this.props.gitAction('');
            }
        }
    }
    setItemState(item) {
        const status = client_core_1.StatusModel.keyToStatus(item.status);
        const notEnLetters = item.name.search(/[А-яЁё]/);
        this.setState({
            id: notEnLetters === -1 ? btoa(item.path + item.name) : btoa(item.path + encodeURIComponent(item.name)),
            status: status,
            statusChar: client_core_1.StatusModel.statusToChar(status),
        });
    }
    render() {
        const { item, isDragging, group, styles } = this.props;
        const { id, status, statusChar } = this.state;
        const className = cx('monaco-tree-row', { 'node-dragging': isDragging }, { 'selected': item.selected === true });
        const statusLable = cx(styles[client_core_1.StatusModel.statusToClass(status)], styles.label);
        return (React.createElement("div", { id: id, className: className },
            React.createElement("div", { className: styles.content },
                React.createElement("div", { onClick: this.handlerOpen, className: styles.labelContainer },
                    React.createElement("div", null,
                        React.createElement("div", { className: statusLable }, statusChar)),
                    React.createElement("div", { className: styles.name }, item.name),
                    item.path ? React.createElement("span", { className: styles.folder }, item.path) : null),
                React.createElement("div", { className: styles.monacoActionBar },
                    group === client_core_1.GROUP.CHANGES &&
                        React.createElement("div", null,
                            React.createElement("div", { className: cx('action-item', styles.actionItem) },
                                React.createElement("div", { className: styles.actionLabelUndo, onClick: this.handlerClean })),
                            React.createElement("div", { className: cx('action-item', styles.actionItem) },
                                React.createElement("div", { className: styles.actionLabelStage, onClick: this.handlerStage }))),
                    group === client_core_1.GROUP.STAGEDCHANGES &&
                        React.createElement("div", { className: cx('action-item', styles.actionItem) },
                            React.createElement("div", { className: styles.actionLabelUnStage, onClick: this.handlerUnstage })),
                    group === client_core_1.GROUP.MERGECHANGES &&
                        React.createElement("div", { className: cx('action-item', styles.actionItem) },
                            React.createElement("div", { className: styles.actionLabelStage, onClick: this.handlerStage }))))));
    }
}
exports.default = react_fela_1.connect({
    content: ({ theme }) => felaStyles.content(),
    monacoActionBar: ({ theme }) => felaStyles.monacoActionBar(),
    actionItem: ({ theme }) => felaStyles.actionItem(),
    actionLabelUndo: ({ theme }) => felaStyles.actionLabelUndo(),
    actionLabelStage: ({ theme }) => felaStyles.actionLabelStage(),
    actionLabelUnStage: ({ theme }) => felaStyles.actionLabelUnStage(),
    modified: ({ theme }) => felaStyles.modified(),
    added: ({ theme }) => felaStyles.added(),
    deleted: ({ theme }) => felaStyles.deleted(),
    renamed: ({ theme }) => felaStyles.renamed(),
    copied: ({ theme }) => felaStyles.copied(),
    untracked: ({ theme }) => felaStyles.untracked(),
    ignored: ({ theme }) => felaStyles.ignored(),
    conflict: ({ theme }) => felaStyles.conflict(),
    label: ({ theme }) => felaStyles.label(),
    labelContainer: ({ theme }) => felaStyles.labelContainer(),
    name: ({ theme }) => felaStyles.name(),
    folder: ({}) => felaStyles.folder(),
})(react_fela_1.withTheme(TreeItemComponent));


/***/ }),
/* 36 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.content = () => ({
    display: 'flex',
    'flex-direction': 'row',
    'justify-content': 'space-between',
    'align-items': 'center',
    ':hover': {
        background: '#e0e0e0',
    },
    ':hover .action-item': {
        opacity: 1,
    },
});
exports.monacoActionBar = () => ({
    'margin-right': '0px',
});
exports.actionItem = () => ({
    opacity: 0,
    cursor: 'pointer',
    display: 'inline-block',
    '-ms-transition': '-ms-transform 50ms ease',
    '-webkit-transition': '-webkit-transform 50ms ease',
    '-moz-transition': '-moz-transform 50ms ease',
    '-o-transition': '-o-transform 50ms ease',
    transition: 'transform 50ms ease',
    position: 'relative',
});
exports.actionLabelUndo = () => ({
    height: '20px',
    width: '20px',
    'font-size': '12px',
    'margin-right': '0.3em',
    display: 'inline-block',
    background: `url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16' viewBox='-0.994 0 16 16' enable-background='new -0.994 0 16 16'%3E%3Cpath fill='%23C5C5C5' d='M13 6c0 1.461-.636 2.846-1.746 3.797l-5.584 4.951-1.324-1.496 5.595-4.962c.678-.582 1.061-1.413 1.061-2.29 0-1.654-1.345-3-2.997-3-.71 0-1.399.253-1.938.713l-1.521 1.287h2.448l-1.998 2h-3.996v-4l1.998-2v2.692l1.775-1.504c.899-.766 2.047-1.188 3.232-1.188 2.754 0 4.995 2.243 4.995 5z'/%3E%3C/svg%3E") center center no-repeat`,
});
exports.actionLabelStage = () => ({
    height: '20px',
    width: '20px',
    'font-size': '12px',
    'margin-right': '0.3em',
    display: 'inline-block',
    background: `url("data:image/svg+xml,%3Csvg width='16' height='16' xmlns='http://www.w3.org/2000/svg'%3E%3Ctitle%3ELayer 1%3C/title%3E%3Crect height='11' width='3' y='3' x='7' fill='%23C5C5C5'/%3E%3Crect height='3' width='11' y='7' x='3' fill='%23C5C5C5'/%3E%3C/svg%3E") center center no-repeat`,
});
exports.actionLabelUnStage = () => ({
    height: '20px',
    width: '20px',
    'font-size': '12px',
    'margin-right': '0.3em',
    display: 'inline-block',
    background: `url("data:image/svg+xml,%3Csvg width='16' height='16' xmlns='http://www.w3.org/2000/svg'%3E%3Ctitle%3ELayer 1%3C/title%3E%3Crect height='3' width='11' y='7' x='3' fill='%23C5C5C5'/%3E%3C/svg%3E") center center no-repeat`,
});
exports.modified = () => ({
    'background-color': '#007ACC',
});
exports.added = () => ({
    'background-color': '#2d883e',
});
exports.deleted = () => ({
    'background-color': '#B9131A',
});
exports.renamed = () => ({
    'background-color': '#4668C5',
});
exports.copied = () => ({
    'background-color': '#682079',
});
exports.untracked = () => ({
    'background-color': '#6C6C6C',
});
exports.ignored = () => ({
    'background-color': '#969696',
});
exports.conflict = () => ({
    'background-color': '#9B4F96',
});
exports.label = () => ({
    padding: '2px 4px',
    'font-family': 'Menlo, Monaco, Consolas, "Droid Sans Mono", "Inconsolata", "Courier New", monospace, "Droid Sans Fallback"',
    'font-size': '70%',
    color: 'white',
    'text-align': 'center',
    'border-radius': '0.5em',
    'vertical-align': 'bottom',
    'margin-right': '5px',
});
exports.labelContainer = () => ({
    display: 'flex',
    'flex-direction': 'row',
    'justify-content': 'center',
});
exports.name = () => ({
    margin: '0 5px',
});
exports.folder = () => ({
    opacity: 0.7,
    'font-size': '0.9em',
    'margin-left': '0.8em',
});


/***/ }),
/* 37 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var TreeGroupHeader_1 = __webpack_require__(38);
exports.TreeGroupHeader = TreeGroupHeader_1.TreeGroupHeader;


/***/ }),
/* 38 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_fela_1 = __webpack_require__(2);
const cx = __webpack_require__(10);
const felaStyles = __webpack_require__(39);
const client_core_1 = __webpack_require__(1);
class TreeGroupHeaderComponent extends React.Component {
    constructor(props) {
        super(props);
        this.handlerClick = (e) => {
            const data = e.target.attributes.getNamedItem('data-action').value;
            this.props.onAction(data);
        };
    }
    render() {
        const { group, count, styles } = this.props;
        const name = group;
        return (React.createElement("div", { className: styles.monacoTreerRow },
            React.createElement("span", { className: styles.titleLable }, name),
            React.createElement("div", { className: styles.infoWrapper },
                React.createElement("div", { className: styles.monacoActionBar },
                    group === client_core_1.GROUP.CHANGES &&
                        React.createElement("div", null,
                            React.createElement("div", { className: cx('action-item', styles.actionItem) },
                                React.createElement("div", { className: styles.actionLabelUndo, "data-action": client_core_1.COMMAND.DISCARD_ALL_CHANGES, onClick: this.handlerClick })),
                            React.createElement("div", { className: cx('action-item', styles.actionItem) },
                                React.createElement("div", { className: styles.actionLabelStage, "data-action": client_core_1.COMMAND.STAGE_ALL, onClick: this.handlerClick }))),
                    group === client_core_1.GROUP.STAGEDCHANGES &&
                        React.createElement("div", { className: cx('action-item', styles.actionItem) },
                            React.createElement("div", { className: styles.actionLabelUnStage, "data-action": client_core_1.COMMAND.UNSTAGE_ALL_CHANGES, onClick: this.handlerClick })),
                    group === client_core_1.GROUP.MERGECHANGES &&
                        React.createElement("div", { className: cx('action-item', styles.actionItem) },
                            React.createElement("div", { className: styles.actionLabelStage, "data-action": client_core_1.COMMAND.STAGE_ALL, onClick: this.handlerClick }))),
                React.createElement("div", { className: styles.countBadgeWrapper },
                    React.createElement("div", { className: styles.monacoCountBadge }, count)))));
    }
}
exports.TreeGroupHeader = react_fela_1.connect({
    monacoTreerRow: ({ theme }) => felaStyles.monacoTreerRow(),
    infoWrapper: ({ theme }) => felaStyles.infoWrapper(),
    countBadgeWrapper: ({ theme }) => felaStyles.countBadgeWrapper(),
    monacoCountBadge: ({ theme }) => felaStyles.monacoCountBadge(),
    monacoActionBar: ({ theme }) => felaStyles.monacoActionBar(),
    titleLable: ({ theme }) => felaStyles.titleLable(),
    actionItem: ({ theme }) => felaStyles.actionItem(),
    actionLabelUndo: ({ theme }) => felaStyles.actionLabelUndo(),
    actionLabelStage: ({ theme }) => felaStyles.actionLabelStage(),
    actionLabelUnStage: ({ theme }) => felaStyles.actionLabelUnStage(),
})(react_fela_1.withTheme(TreeGroupHeaderComponent));


/***/ }),
/* 39 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.monacoTreerRow = () => ({
    display: 'flex',
    'justify-content': 'space-between',
    '-moz-box-sizing': 'border-box',
    '-o-box-sizing': 'border-box',
    '-ms-box-sizing': 'border-box',
    'box-sizing': 'border-box',
    cursor: 'pointer',
    overflow: 'hidden',
    width: '100%',
    'touch-action': 'none',
    padding: '5px 10px',
    ':hover .action-item': {
        opacity: 1,
    },
    ':hover': {
        background: '#e0e0e0',
    },
});
exports.infoWrapper = () => ({
    display: 'flex',
});
exports.countBadgeWrapper = () => ({
    padding: '1px 7px',
    'border-radius': '10px',
    position: 'absolute',
    right: 0,
    background: '#4D4D4D',
});
exports.monacoCountBadge = () => ({
    color: '#FFF',
});
exports.monacoActionBar = () => ({
    'margin-right': '20px',
});
exports.titleLable = () => ({
    'text-transform': 'capitalize',
    'font-weight': 'bold',
});
exports.actionItem = () => ({
    opacity: 0,
    cursor: 'pointer',
    display: 'inline-block',
    '-ms-transition': '-ms-transform 50ms ease',
    '-webkit-transition': '-webkit-transform 50ms ease',
    '-moz-transition': '-moz-transform 50ms ease',
    '-o-transition': '-o-transform 50ms ease',
    transition: 'transform 50ms ease',
    position: 'relative',
});
exports.actionLabelUndo = () => ({
    height: '15px',
    width: '20px',
    'font-size': '12px',
    'margin-right': '0.3em',
    display: 'inline-block',
    background: `url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16' viewBox='-0.994 0 16 16' enable-background='new -0.994 0 16 16'%3E%3Cpath fill='%23C5C5C5' d='M13 6c0 1.461-.636 2.846-1.746 3.797l-5.584 4.951-1.324-1.496 5.595-4.962c.678-.582 1.061-1.413 1.061-2.29 0-1.654-1.345-3-2.997-3-.71 0-1.399.253-1.938.713l-1.521 1.287h2.448l-1.998 2h-3.996v-4l1.998-2v2.692l1.775-1.504c.899-.766 2.047-1.188 3.232-1.188 2.754 0 4.995 2.243 4.995 5z'/%3E%3C/svg%3E") center center no-repeat`,
});
exports.actionLabelStage = () => ({
    height: '15px',
    width: '20px',
    'font-size': '12px',
    'margin-right': '0.3em',
    display: 'inline-block',
    background: `url("data:image/svg+xml,%3Csvg width='16' height='16' xmlns='http://www.w3.org/2000/svg'%3E%3Ctitle%3ELayer 1%3C/title%3E%3Crect height='11' width='3' y='3' x='7' fill='%23C5C5C5'/%3E%3Crect height='3' width='11' y='7' x='3' fill='%23C5C5C5'/%3E%3C/svg%3E") center center no-repeat`,
});
exports.actionLabelUnStage = () => ({
    height: '15px',
    width: '20px',
    'font-size': '12px',
    'margin-right': '0.3em',
    display: 'inline-block',
    background: `url("data:image/svg+xml,%3Csvg width='16' height='16' xmlns='http://www.w3.org/2000/svg'%3E%3Ctitle%3ELayer 1%3C/title%3E%3Crect height='3' width='11' y='7' x='3' fill='%23C5C5C5'/%3E%3C/svg%3E") center center no-repeat`,
});


/***/ }),
/* 40 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_fela_1 = __webpack_require__(2);
const StatusViewRule = (props) => ({
    overflowY: 'auto',
    maxHeight: '90vh',
});
exports.StatusView = react_fela_1.createComponent(StatusViewRule, 'div');


/***/ }),
/* 41 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const classNames = __webpack_require__(10);
const react_fela_1 = __webpack_require__(2);
class InputBoxComponent extends React.Component {
    constructor(props) {
        super(props);
        const { options } = props;
        const placeholder = options.placeholder || '';
        this.state = { stateType: 'ide', placeholder: placeholder, focus: true };
    }
    render() {
        const { options, onChange, onKeyPress, styles } = this.props;
        const { stateType, placeholder, focus } = this.state;
        const boxClass = focus ?
            classNames(styles.monacoInputbox, stateType, 'synthetic-focus') :
            classNames(styles.monacoInputbox, stateType);
        return (React.createElement("div", { className: boxClass }, options.flexibleHeight ?
            React.createElement("div", { className: "wrapper" },
                React.createElement("textarea", { className: styles.input, placeholder: placeholder, onChange: onChange, value: options.value }),
                React.createElement("div", { className: "mirror" }))
            :
                React.createElement("div", { className: "wrapper", onKeyPress: onKeyPress },
                    React.createElement("input", { className: styles.input, placeholder: placeholder, onChange: onChange, value: options.value, type: options.type || 'text' }))));
    }
}
exports.InputBox = react_fela_1.connect({
    input: ({ theme }) => ({
        width: '100%',
        margin: '10px 0',
        padding: '5px',
    }),
    monacoInputbox: ({ theme }) => ({
        width: '100%',
    }),
})(react_fela_1.withTheme(InputBoxComponent));


/***/ }),
/* 42 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_redux_1 = __webpack_require__(3);
const client_redux_1 = __webpack_require__(4);
const client_modal_redux_1 = __webpack_require__(5);
const EmptyGitView_1 = __webpack_require__(43);
const mapDispatchToProps = (dispatch) => ({
    setError(error, type) {
        dispatch(client_modal_redux_1.setError(error, 'error'));
    },
    showInputModal(description, dataType, placeholder, inputType) {
        dispatch(client_modal_redux_1.showInputModal(description, dataType, placeholder, inputType));
    },
    gitAction(command, args) {
        dispatch(client_redux_1.gitAction(command, args));
    },
});
exports.EmptyGitView = react_redux_1.connect(null, mapDispatchToProps)(EmptyGitView_1.default);


/***/ }),
/* 43 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_fela_1 = __webpack_require__(2);
const client_core_1 = __webpack_require__(1);
const client_core_2 = __webpack_require__(1);
const ActionItemView_1 = __webpack_require__(12);
class EmptyGitViewComponent extends React.Component {
    constructor(props) {
        super(props);
        this.handlerInit = () => {
        };
        this.handlerClone = () => {
            this.props.showInputModal(client_core_1.DESCRIPTION.PEROSITORY, client_core_2.DATA_TYPE.REPOSITORY, client_core_1.PLACEHOLDER.PEROSITORY);
            this.props.gitAction(client_core_1.COMMAND.CLONE);
        };
        this.handlerChange = e => this.setState({ path: e.target.value });
        this.state = {
            path: '',
        };
    }
    render() {
        const { styles } = this.props;
        return (React.createElement("div", { className: styles.container },
            React.createElement("div", { className: styles.actionsView },
                React.createElement("span", null, "Source control"),
                React.createElement("div", { className: styles.actionsBar },
                    React.createElement(ActionItemView_1.ActionItemView, { title: "init", icon: "iconGit", onClick: this.handlerInit }))),
            React.createElement("div", { className: styles.descriptionRule }, "There are no active source control providers"),
            React.createElement("div", null,
                React.createElement("button", { onClick: this.handlerClone }, "Clone project"))));
    }
}
exports.default = react_fela_1.connect({
    descriptionRule: ({ theme }) => ({
        margin: '10px 0',
    }),
    actionsBar: ({ theme }) => ({
        display: 'flex',
    }),
    actionsView: ({ theme }) => ({
        display: 'flex',
        'justify-content': 'space-between',
    }),
    container: ({ theme }) => ({
        padding: '10px',
    }),
})(react_fela_1.withTheme(EmptyGitViewComponent));


/***/ }),
/* 44 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(45));
__export(__webpack_require__(48));


/***/ }),
/* 45 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_redux_1 = __webpack_require__(3);
const react_apollo_1 = __webpack_require__(7);
const reselect_1 = __webpack_require__(13);
const client_modal_redux_1 = __webpack_require__(5);
const client_layout_redux_1 = __webpack_require__(46);
const client_redux_1 = __webpack_require__(4);
const graphql_gql_1 = __webpack_require__(8);
const CheckoutView_1 = __webpack_require__(47);
const GitFooterWithData = react_apollo_1.compose(react_apollo_1.graphql(graphql_gql_1.OPEN_MUTATE, { name: 'openMutate' }), react_apollo_1.graphql(graphql_gql_1.CHECKOUT_MUTATE, { name: 'checkoutMutate' }), react_apollo_1.graphql(graphql_gql_1.SYNC_MUTATE, { name: 'syncMutate' }), react_apollo_1.graphql(graphql_gql_1.SAVE_USER, { name: 'saveUserMutate' }), react_apollo_1.graphql(graphql_gql_1.PULL_MUTATE, { name: 'pullMutate' }), react_apollo_1.graphql(graphql_gql_1.PUSH_MUTATE, { name: 'pushMutate' }), react_apollo_1.graphql(graphql_gql_1.REFS_QUERY, {
    props: reselect_1.createSelector(({ ownProps, data }) => data, (data) => { return { refs: data.refs, refsRefetch: data.refetch }; })
}), react_apollo_1.graphql(graphql_gql_1.AUTH_DATA, {
    skip: ({ gitAuth }) => !gitAuth.userId || !gitAuth.isAuth,
    options: ({ gitAuth }) => ({ variables: { id: gitAuth.userId } }),
    props: reselect_1.createSelector(({ data: { auth, error, refetch } }) => ({ error, auth, refetch }), ({ error, auth, refetch }) => ({ authData: auth, error, authRefetch: refetch })),
}), react_apollo_1.graphql(graphql_gql_1.STATUS_QUERY, {
    skip: ({ git }) => !git.isPathConfirm,
    props: reselect_1.createSelector(({ ownProps, data }) => data, (data) => {
        const status = data.status ? data.status.status : [];
        const currentBranch = data.status ? data.status.currentBranch : null;
        return {
            statusInfo: status,
            refetch: data.refetch,
            branch: currentBranch,
        };
    }),
}))(CheckoutView_1.default);
const mapStateToProps = (state) => ({
    git: state.git_stack_commands,
    rootpath: state['@files/rootpath'],
    selectedModal: state.selectModal.selected,
    gitAuth: state.git_stack_auth,
    inputSelected: state.modalInput,
});
const mapDispatchToProps = (dispatch) => ({
    gitAction(command, args) {
        dispatch(client_redux_1.gitAction(command, args));
    },
    confirmPath(path) {
        dispatch(client_redux_1.confirmPath(path));
    },
    setError(error, type) {
        dispatch(client_modal_redux_1.setError(error, type));
    },
    setCurrentBranch(name) {
        dispatch(client_redux_1.setCurrentBranch(name));
    },
    showSelectModal(data, dataType, placeholder) {
        dispatch(client_modal_redux_1.showSelectModal(data, dataType, placeholder));
    },
    setRefs(refs) {
        dispatch(client_redux_1.setRefs(refs));
    },
    setTreeData(data) {
        dispatch(client_redux_1.setTreeData(data));
    },
    resetGit() {
        dispatch(client_redux_1.resetGit());
    },
    setTabInfo(tabName, message) {
        dispatch(client_layout_redux_1.setTabInfo(tabName, message));
    },
    checkAuth() {
        dispatch(client_redux_1.checkAuth());
    },
    setAuth() {
        dispatch(client_redux_1.setAuth());
    },
    authCleanGit() {
        dispatch(client_redux_1.authCleanGit());
    },
    saveUser(id) {
        dispatch(client_redux_1.saveUser(id));
    },
    showInputModal(description, dataType, placeholder, inputType) {
        dispatch(client_modal_redux_1.showInputModal(description, dataType, placeholder, inputType));
    },
    clearInputValue() {
        dispatch(client_modal_redux_1.clearInputValue());
    },
    loginSetGit(login) {
        dispatch(client_redux_1.loginSetGit(login));
    },
    passSetGit(password) {
        dispatch(client_redux_1.passSetGit(password));
    },
    commitSetGit(commit) {
        dispatch(client_redux_1.commitSetGit(commit));
    },
    setCloneData(key, value) {
        dispatch(client_redux_1.setCloneData(key, value));
    },
    setBranch(name) {
        dispatch(client_redux_1.setBranch(name));
    },
    setTag(key, value) {
        dispatch(client_redux_1.setTag(key, value));
    },
    setStashMessage(mesage) {
        dispatch(client_redux_1.setStashMessage(mesage));
    },
    cleanBranch() {
        dispatch(client_redux_1.cleanBranch());
    },
});
exports.CheckoutView = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(GitFooterWithData);


/***/ }),
/* 46 */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/client-layout-redux");

/***/ }),
/* 47 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const lodash_1 = __webpack_require__(9);
const client_core_1 = __webpack_require__(1);
const utils_1 = __webpack_require__(6);
class GitCheckoutContainer extends React.Component {
    constructor(props) {
        super(props);
        this.onGitAction = (git, authData, selectedModal) => {
            switch (git.command) {
                case client_core_1.COMMAND.OPEN:
                    if (this.props.git.command === client_core_1.COMMAND.OPEN) {
                        return;
                    }
                    return this.actionOpen(git.args);
                case client_core_1.COMMAND.SHOW_BRANCHES_LIST:
                case client_core_1.COMMAND.SHOW_CHECKOUT_BRANCHES_LIST:
                case client_core_1.COMMAND.SHOW_MERGE_BRANCHES_LIST:
                    return this.actionShowBranch(git.command);
                case client_core_1.COMMAND.CHECKOUT_TO:
                    if (!selectedModal) {
                        return;
                    }
                    return this.doAction(this.actionCheckout(selectedModal));
                case client_core_1.COMMAND.SYNC:
                    if (!authData) {
                        return;
                    }
                    return this.doAction(this.actionSync(authData.login, authData.endpoint));
                case client_core_1.COMMAND.PULL:
                    if (!authData) {
                        return;
                    }
                    return this.doAction(this.actionPull(authData.login, authData.endpoint));
                case client_core_1.COMMAND.PULL_REBASE:
                    if (!authData) {
                        return;
                    }
                    return this.actionPull(authData.login, authData.endpoint, true);
                case client_core_1.COMMAND.PULL_FROM:
                    if (!git.branch || !authData) {
                        return;
                    }
                    return this.actionPull(authData.login, authData.endpoint, false, git.branch);
                case client_core_1.COMMAND.PUSH:
                    if (!authData) {
                        return;
                    }
                    return this.actionPush(authData.login, authData.endpoint);
                case client_core_1.COMMAND.PUSH_WITH_TAGS:
                    if (!authData) {
                        return;
                    }
                    return this.actionPush(authData.login, authData.endpoint, null, null, { tags: true });
                case client_core_1.COMMAND.PUSH_TO:
                    if (!git.branch || !authData) {
                        return;
                    }
                    return this.actionPush(authData.login, authData.endpoint, 'origin', git.branch);
                case client_core_1.COMMAND.PUBLISH_BRANCH:
                    if (!authData) {
                        return;
                    }
                    return this.actionPush(authData.login, authData.endpoint, 'origin', git.currentBranch, { setUpstream: true });
                default:
                    return;
            }
        };
        this.actionOpen = (path) => {
            this.props.openMutate({ variables: { path } })
                .then(({ data }) => {
                if (!data.open.setPath.error) {
                    this.props.confirmPath(path);
                }
                else {
                    this.props.setError(data.open.setPath.error, 'error');
                }
                this.props.gitAction('');
            })
                .catch(err => console.log('error', err));
        };
        this.actionRefetch = () => {
            this.props.refetch();
        };
        this.actionShowBranch = command => {
            const { showSelectModal, gitAction, git: { refs, currentBranch } } = this.props;
            let heads;
            if (command === client_core_1.COMMAND.SHOW_BRANCHES_LIST) {
                heads = refs.filter(ref => ref.type === client_core_1.RefType.Head && ref.name !== currentBranch);
            }
            else {
                heads = refs.filter(ref => (ref.type === client_core_1.RefType.Head || ref.type === client_core_1.RefType.RemoteHead) && ref.name !== currentBranch);
            }
            heads = lodash_1.map(heads, 'name');
            if (!heads.length) {
                gitAction('');
                return this.props.setError('There is no entries to pick from', 'warn');
            }
            if (command === client_core_1.COMMAND.SHOW_BRANCHES_LIST) {
                showSelectModal(heads, 'branch', 'select a branch to delete');
                gitAction(client_core_1.COMMAND.DELETE_BRANCH);
            }
            else if (command === 'showCheckoutBranchesList') {
                showSelectModal(heads, 'checkout', 'select a ref to checkout');
                gitAction(client_core_1.COMMAND.CHECKOUT_TO);
            }
            else if (command === 'showMergeBranchesList') {
                showSelectModal(heads, 'merge', 'select a branch to merge from');
                gitAction(client_core_1.COMMAND.MERGE_BRANCH);
            }
        };
        this.actionCheckout = (name) => {
            const ref = lodash_1.find(this.props.git.refs, { name });
            if (ref.type === client_core_1.RefType.RemoteHead) {
                const index = name.indexOf('/');
                name = name.substring(index + 1, name.length + 1);
            }
            return this.props.checkoutMutate({ variables: { name } })
                .then(({ data }) => {
                if (!data.checkout.exitCode) {
                    this.props.setCurrentBranch(data.checkout.currentBranch);
                    this.props.setError(`Checkout to '${data.checkout.currentBranch}'`, 'info');
                }
                return data.checkout;
            });
        };
        this.actionSync = (login, password) => {
            return this.props.syncMutate({
                variables: { options: { login, password } },
            }).then(({ data }) => data.sync);
        };
        this.actionSaveUser = (login, endpoint) => {
            this.props.authCleanGit();
            return this.props.saveUserMutate({
                variables: { login, endpoint },
            }).then(({ data }) => {
                this.props.saveUser(data.saveUser.id);
                localStorage.setItem('userId', data.saveUser.id);
            });
        };
        this.actionPull = (login, password, rebase, branch) => {
            this.props.cleanBranch();
            return this.props.pullMutate({
                variables: { options: { login, password, rebase, branch } },
            }).then(({ data }) => data.pull);
        };
        this.actionPush = (login, password, remote, name, options) => {
            return this.props.pushMutate({
                variables: { options: Object.assign({ login, password }, options), remote, name },
            }).then(({ data }) => {
                if (data.push.exitCode) {
                    this.props.setError(utils_1.getErrorText(data.push), 'error');
                }
            });
        };
        this.handlerClickBranch = () => {
            this.props.gitAction(client_core_1.COMMAND.SHOW_CHECKOUT_BRANCHES_LIST);
        };
        this.handlerClickSync = () => {
            this.props.checkAuth();
            this.props.gitAction(client_core_1.COMMAND.SYNC);
        };
        this.state = {
            timer: null,
        };
    }
    componentWillMount() {
        const { rootpath, git, gitAction } = this.props;
        if (rootpath && !git.isPathConfirm) {
            gitAction(client_core_1.COMMAND.OPEN, rootpath);
        }
    }
    componentDidMount() {
        if (this.props.refetch) {
            let timer = setInterval(this.actionRefetch, 5000);
            this.setState({ timer });
        }
    }
    componentWillReceiveProps(nextProps) {
        const { git, statusInfo, branch, refs, selectedModal, setTabInfo, authData, gitAuth, inputSelected: { selected, dataType }, clearInputValue, loginSetGit, showInputModal, passSetGit, commitSetGit, setCloneData, setBranch, setTag, setStashMessage } = nextProps;
        const { statusInfo: statusInfoPrev, branch: branchPrev, refs: refsPrev, git: gitPrev, setCurrentBranch, setRefs, refsRefetch } = this.props;
        if (git && git.calling) {
            let auth;
            if (gitAuth.loginStep === 2) {
                auth = { login: gitAuth.login, endpoint: gitAuth.password };
            }
            if (authData) {
                auth = authData;
            }
            this.onGitAction(git, auth, selectedModal);
        }
        if (git.getRefs) {
            refsRefetch();
        }
        if (statusInfo && statusInfoPrev && statusInfo.length !== statusInfoPrev.length) {
            setTabInfo('git', statusInfo.length === 0 ? null : statusInfo.length.toString());
        }
        if (authData) {
            this.props.setAuth();
        }
        if (gitAuth.loginStep === 2) {
            this.actionSaveUser(gitAuth.login, gitAuth.password);
        }
        if (branch !== branchPrev) {
            setCurrentBranch(branch);
        }
        if ((!gitPrev.refs && refs) || refsPrev !== refs) {
            setRefs(refs);
        }
        if ((git.command === client_core_1.COMMAND.PULL || git.command === client_core_1.COMMAND.PULL_REBASE ||
            git.command === client_core_1.COMMAND.PUSH || git.command === client_core_1.COMMAND.SYNC ||
            git.command === client_core_1.COMMAND.PUBLISH_BRANCH) && git.command !== gitPrev.command) {
            if (!gitAuth.userId) {
                this.props.showInputModal(client_core_1.DESCRIPTION.LOGIN, client_core_1.DATA_TYPE.LOGIN, client_core_1.PLACEHOLDER.LOGIN);
            }
            else {
                this.props.setAuth();
            }
        }
        if (selected) {
            clearInputValue();
            switch (dataType) {
                case client_core_1.DATA_TYPE.LOGIN:
                    loginSetGit(selected);
                    return showInputModal(client_core_1.DESCRIPTION.PASSWORD, client_core_1.DATA_TYPE.PASSWORD, client_core_1.PLACEHOLDER.PASSWORD, 'password');
                case client_core_1.DATA_TYPE.PASSWORD:
                    return passSetGit(selected);
                case client_core_1.DATA_TYPE.COMMIT:
                    return commitSetGit(selected);
                case client_core_1.DATA_TYPE.REPOSITORY:
                    setCloneData(client_core_1.COMMON.REPOSITORY, selected);
                    return showInputModal(client_core_1.DESCRIPTION.PATH, client_core_1.DATA_TYPE.PATH, client_core_1.PLACEHOLDER.PATH);
                case client_core_1.DATA_TYPE.PATH:
                    setCloneData(client_core_1.COMMON.ROOTPATH, selected);
                    return showInputModal(client_core_1.DESCRIPTION.LOGIN, client_core_1.DATA_TYPE.LOGIN, client_core_1.PLACEHOLDER.LOGIN);
                case client_core_1.DATA_TYPE.BRANCH:
                    return setBranch(selected);
                case client_core_1.DATA_TYPE.TAG:
                    setTag(client_core_1.COMMON.TAG, selected);
                    return showInputModal(client_core_1.DESCRIPTION.TAG_MESSAGE, client_core_1.DATA_TYPE.TAG_MESSAGE, client_core_1.PLACEHOLDER.MESSAGE);
                case client_core_1.DATA_TYPE.TAG_MESSAGE:
                    return setTag(client_core_1.COMMON.TAG_MESSAGE, selected);
                case client_core_1.DATA_TYPE.STASH:
                    return setStashMessage(selected);
                case client_core_1.DATA_TYPE.PULL_FROM:
                case client_core_1.DATA_TYPE.PUSH_TO:
                    setBranch(selected);
                    if (!this.props.gitAuth.userId) {
                        return this.props.showInputModal(client_core_1.DESCRIPTION.LOGIN, client_core_1.DATA_TYPE.LOGIN, client_core_1.PLACEHOLDER.LOGIN);
                    }
                    else {
                        return this.props.setAuth();
                    }
                default:
                    return;
            }
        }
    }
    componentWillUnmount() {
        this.setState({ timer: null });
    }
    doAction(promise) {
        this.props.gitAction('');
        promise.then((data) => {
            this.props.setTreeData(client_core_1.convertGitStatusToChanges(data.status));
            this.props.resetGit();
            if (data.exitCode) {
                return this.props.setError(utils_1.getErrorText(data), 'error');
            }
        }).catch((error) => {
            this.props.setError(utils_1.getErrorText(error), 'error');
        });
    }
    render() {
        const { styles, branch } = this.props;
        return (React.createElement("div", { onClick: this.handlerClickBranch }, branch));
    }
}
exports.default = GitCheckoutContainer;


/***/ }),
/* 48 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(0);
const react_redux_1 = __webpack_require__(3);
const client_core_1 = __webpack_require__(1);
const client_redux_1 = __webpack_require__(4);
class GitSyncContainer extends React.Component {
    constructor() {
        super(...arguments);
        this.handlerClickSync = () => {
            this.props.checkAuth();
            this.props.gitAction(client_core_1.COMMAND.SYNC);
        };
    }
    render() {
        return (React.createElement("div", { onClick: this.handlerClickSync }, "sync"));
    }
}
const mapDispatchToProps = (dispatch) => ({
    gitAction(command, args) {
        dispatch(client_redux_1.gitAction(command, args));
    },
    checkAuth() {
        dispatch(client_redux_1.checkAuth());
    },
});
exports.SyncView = react_redux_1.connect(null, mapDispatchToProps)(GitSyncContainer);


/***/ })
/******/ ]);
//# sourceMappingURL=index.js.map